--- php-8.4.18/ext/ffi/tests/gh18629_cdef_resolve_func.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/ffi/tests/gh18629_cdef_resolve_func.phpt	2026-04-01 04:35:36.005985062 +0000
@@ -0,0 +1,16 @@
+--TEST--
+GH-18629 (FFI::cdef() leaks on function resolution failure)
+--EXTENSIONS--
+ffi
+--INI--
+ffi.enable=1
+--FILE--
+<?php
+try {
+	$ffi = FFI::cdef("void nonexistent_ffi_test_func(void);");
+} catch (\FFI\Exception $e) {
+	echo $e->getMessage() . "\n";
+}
+?>
+--EXPECT--
+Failed resolving C function 'nonexistent_ffi_test_func'
diff '--color=auto' -Naur php-8.4.18/ext/ffi/tests/gh18629_read_field_non_struct.phpt php-8.4.20RC1/ext/ffi/tests/gh18629_read_field_non_struct.phpt
--- php-8.4.18/ext/ffi/tests/gh18629_read_field_non_struct.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/ffi/tests/gh18629_read_field_non_struct.phpt	2026-04-01 04:35:36.006051738 +0000
@@ -0,0 +1,17 @@
+--TEST--
+GH-18629 (Read field of non C struct/union)
+--EXTENSIONS--
+ffi
+--INI--
+ffi.enable=1
+--FILE--
+<?php
+$x = FFI::cdef()->new("int*");
+try {
+	$y = $x->foo;
+} catch (\FFI\Exception $e) {
+	echo $e->getMessage() . "\n";
+}
+?>
+--EXPECT--
+Attempt to read field 'foo' of non C struct/union
diff '--color=auto' -Naur php-8.4.18/ext/filter/logical_filters.c php-8.4.20RC1/ext/filter/logical_filters.c
--- php-8.4.18/ext/filter/logical_filters.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/filter/logical_filters.c	2026-04-01 04:35:36.006187675 +0000
@@ -723,7 +723,7 @@
 }
 /* }}} */
 
-static int _php_filter_validate_ipv4(char *str, size_t str_len, int *ip) /* {{{ */
+static int _php_filter_validate_ipv4(const char *str, size_t str_len, int *ip) /* {{{ */
 {
 	const char *end = str + str_len;
 	int num, m;
@@ -764,7 +764,7 @@
 	int blocks = 0;
 	unsigned int num, n;
 	int i;
-	char *ipv4;
+	const char *ipv4;
 	const char *end;
 	int ip4elm[4];
 	const char *s = str;
diff '--color=auto' -Naur php-8.4.18/ext/gd/libgd/gd_jpeg.c php-8.4.20RC1/ext/gd/libgd/gd_jpeg.c
--- php-8.4.18/ext/gd/libgd/gd_jpeg.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/gd/libgd/gd_jpeg.c	2026-04-01 04:35:36.006338480 +0000
@@ -125,6 +125,10 @@
 			return "9 compatible";
 			break;
 
+		case 100:
+			return "10 compatible";
+			break;
+
 		default:
 			return "unknown";
 	}
diff '--color=auto' -Naur php-8.4.18/ext/gd/tests/bug77270.phpt php-8.4.20RC1/ext/gd/tests/bug77270.phpt
--- php-8.4.18/ext/gd/tests/bug77270.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/gd/tests/bug77270.phpt	2026-04-01 04:35:36.006463797 +0000
@@ -1,7 +1,5 @@
 --TEST--
 Bug #77270 (imagecolormatch Out Of Bounds Write on Heap)
---INI--
-memory_limit=-1
 --EXTENSIONS--
 gd
 --SKIPIF--
diff '--color=auto' -Naur php-8.4.18/ext/gd/tests/bug77272.phpt php-8.4.20RC1/ext/gd/tests/bug77272.phpt
--- php-8.4.18/ext/gd/tests/bug77272.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/gd/tests/bug77272.phpt	2026-04-01 04:35:36.006530563 +0000
@@ -6,6 +6,7 @@
 gd
 --SKIPIF--
 <?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
 if (!GD_BUNDLED && version_compare(GD_VERSION, '2.2.5', '<=')) die('skip upstream fix not yet released');
 if (getenv("SKIP_SLOW_TESTS")) die("skip slow test");
 if (substr(PHP_OS, 0, 3) == 'WIN' && PHP_INT_SIZE === 4) die("skip not for Windows x86");
diff '--color=auto' -Naur php-8.4.18/ext/gd/tests/bug77479.phpt php-8.4.20RC1/ext/gd/tests/bug77479.phpt
--- php-8.4.18/ext/gd/tests/bug77479.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/gd/tests/bug77479.phpt	2026-04-01 04:35:36.006613860 +0000
@@ -4,6 +4,7 @@
 gd
 --SKIPIF--
 <?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
 if (getenv("SKIP_SLOW_TESTS")) die("skip slow test");
 ?>
 --INI--
diff '--color=auto' -Naur php-8.4.18/ext/gd/tests/gh16322.phpt php-8.4.20RC1/ext/gd/tests/gh16322.phpt
--- php-8.4.18/ext/gd/tests/gh16322.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/gd/tests/gh16322.phpt	2026-04-01 04:35:36.006683772 +0000
@@ -2,8 +2,6 @@
 GH-16322 (imageaffine overflow/underflow on affine matrix)
 --EXTENSIONS--
 gd
---INI--
-memory_limit=-1
 --FILE--
 <?php
 $matrix = [INF, 1, 1, 1, 1, 1];
diff '--color=auto' -Naur php-8.4.18/ext/iconv/iconv.c php-8.4.20RC1/ext/iconv/iconv.c
--- php-8.4.18/ext/iconv/iconv.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/iconv/iconv.c	2026-04-01 04:35:36.006821392 +0000
@@ -320,7 +320,7 @@
 
 		if (mimetype != NULL && (!(output_context->op & PHP_OUTPUT_HANDLER_CLEAN) || ((output_context->op & PHP_OUTPUT_HANDLER_START) && !(output_context->op & PHP_OUTPUT_HANDLER_FINAL)))) {
 			size_t len;
-			char *p = strstr(get_output_encoding(), "//");
+			const char *p = strstr(get_output_encoding(), "//");
 
 			if (p) {
 				len = spprintf(&content_type, 0, "Content-Type:%.*s; charset=%.*s", mimetype_len ? mimetype_len : (int) strlen(mimetype), mimetype, (int) (p - get_output_encoding()), get_output_encoding());
@@ -2577,7 +2577,7 @@
 {
 	php_stream_filter *retval = NULL;
 	php_iconv_stream_filter *inst;
-	char *from_charset = NULL, *to_charset = NULL;
+	const char *from_charset = NULL, *to_charset = NULL;
 	size_t from_charset_len, to_charset_len;
 
 	if ((from_charset = strchr(name, '.')) == NULL) {
diff '--color=auto' -Naur php-8.4.18/ext/ldap/tests/GHSA-g665-fm4p-vhff-1.phpt php-8.4.20RC1/ext/ldap/tests/GHSA-g665-fm4p-vhff-1.phpt
--- php-8.4.18/ext/ldap/tests/GHSA-g665-fm4p-vhff-1.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/ldap/tests/GHSA-g665-fm4p-vhff-1.phpt	2026-04-01 04:35:36.007008837 +0000
@@ -6,6 +6,7 @@
 memory_limit=-1
 --SKIPIF--
 <?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
 if (PHP_INT_SIZE !== 4) die("skip only for 32-bit");
 if (getenv("SKIP_SLOW_TESTS")) die("skip slow test");
 ?>
diff '--color=auto' -Naur php-8.4.18/ext/ldap/tests/GHSA-g665-fm4p-vhff-2.phpt php-8.4.20RC1/ext/ldap/tests/GHSA-g665-fm4p-vhff-2.phpt
--- php-8.4.18/ext/ldap/tests/GHSA-g665-fm4p-vhff-2.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/ldap/tests/GHSA-g665-fm4p-vhff-2.phpt	2026-04-01 04:35:36.007070102 +0000
@@ -6,6 +6,7 @@
 memory_limit=-1
 --SKIPIF--
 <?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
 if (PHP_INT_SIZE !== 4) die("skip only for 32-bit");
 if (getenv("SKIP_SLOW_TESTS")) die("skip slow test");
 ?>
diff '--color=auto' -Naur php-8.4.18/ext/mbstring/mbstring.c php-8.4.20RC1/ext/mbstring/mbstring.c
--- php-8.4.18/ext/mbstring/mbstring.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/mbstring/mbstring.c	2026-04-01 04:35:36.007301119 +0000
@@ -3376,8 +3376,9 @@
 		return *elist;
 	}
 
-	/* Allocate on stack; when we return, this array is automatically freed */
-	struct candidate *array = alloca(elist_size * sizeof(struct candidate));
+	/* Allocate on stack or heap */
+	ALLOCA_FLAG(use_heap)
+	struct candidate *array = do_alloca(elist_size * sizeof(struct candidate), use_heap);
 	elist_size = init_candidate_array(array, elist_size, elist, strings, str_lengths, n, strict, order_significant);
 
 	while (n--) {
@@ -3385,6 +3386,7 @@
 		elist_size = count_demerits(array, elist_size, strict);
 		if (elist_size == 0) {
 			/* All candidates were eliminated */
+			free_alloca(array, use_heap);
 			return NULL;
 		}
 	}
@@ -3396,7 +3398,10 @@
 			best = i;
 		}
 	}
-	return array[best].enc;
+
+	const mbfl_encoding *result = array[best].enc;
+	free_alloca(array, use_heap);
+	return result;
 }
 
 /* When doing 'strict' detection, any string which is invalid in the candidate encoding
diff '--color=auto' -Naur php-8.4.18/ext/mbstring/tests/gh20836_stack_limit.phpt php-8.4.20RC1/ext/mbstring/tests/gh20836_stack_limit.phpt
--- php-8.4.18/ext/mbstring/tests/gh20836_stack_limit.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/mbstring/tests/gh20836_stack_limit.phpt	2026-04-01 04:35:36.007676358 +0000
@@ -12,7 +12,7 @@
 }
 ?>
 --INI--
-zend.max_allowed_stack_size=128K
+zend.max_allowed_stack_size=256K
 --FILE--
 <?php
 
diff '--color=auto' -Naur php-8.4.18/ext/mbstring/tests/gh21223.phpt php-8.4.20RC1/ext/mbstring/tests/gh21223.phpt
--- php-8.4.18/ext/mbstring/tests/gh21223.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/mbstring/tests/gh21223.phpt	2026-04-01 04:35:36.007744567 +0000
@@ -0,0 +1,19 @@
+--TEST--
+GH-21223 (Stack overflow in mb_guess_encoding called via mb_detect_encoding)
+--EXTENSIONS--
+mbstring
+--FILE--
+<?php
+$str = "hello";
+
+$list = [];
+for ($i = 0; $i < 500000; $i++) {
+    $list[] = "UTF-8";
+}
+
+var_dump(mb_detect_encoding($str, $list, false));
+echo "Done";
+?>
+--EXPECT--
+string(5) "UTF-8"
+Done
diff '--color=auto' -Naur php-8.4.18/ext/opcache/jit/ir/ir_aarch64.dasc php-8.4.20RC1/ext/opcache/jit/ir/ir_aarch64.dasc
--- php-8.4.18/ext/opcache/jit/ir/ir_aarch64.dasc	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/jit/ir/ir_aarch64.dasc	2026-04-01 04:35:36.008443898 +0000
@@ -60,7 +60,7 @@
 #define ADR_IMM         (1<<20)        // signed imm21
 #define ADRP_IMM        (1LL<<32)      // signed imm21 * 4096
 
-static bool aarch64_may_use_b(ir_code_buffer *code_buffer, const void *addr)
+static bool aarch64_may_use_b(const ir_code_buffer *code_buffer, const void *addr)
 {
 	if (code_buffer) {
 		if (addr >= code_buffer->start && (char*)addr < (char*)code_buffer->end) {
@@ -824,6 +824,34 @@
 	}
 }
 
+static bool all_usages_are_fusable(ir_ctx *ctx, ir_ref ref)
+{
+	ir_insn *insn = &ctx->ir_base[ref];
+
+	if (insn->op >= IR_EQ && insn->op <= IR_UNORDERED) {
+		ir_use_list *use_list = &ctx->use_lists[ref];
+		ir_ref n = use_list->count;
+
+		if (n > 0) {
+			ir_ref *p = ctx->use_edges + use_list->refs;
+
+			do {
+				insn = &ctx->ir_base[*p];
+				if (insn->op != IR_IF
+				 && insn->op != IR_GUARD
+				 && insn->op != IR_GUARD_NOT) {
+					return 0;
+				}
+				p++;
+				n--;
+			} while (n);
+			return 1;
+		}
+	}
+	return 0;
+}
+
+
 static uint32_t ir_match_insn(ir_ctx *ctx, ir_ref ref)
 {
 	ir_insn *op2_insn;
@@ -1145,7 +1173,7 @@
 				return IR_RETURN_FP;
 			}
 		case IR_IF:
-			if (!IR_IS_CONST_REF(insn->op2) && ctx->use_lists[insn->op2].count == 1) {
+			if (!IR_IS_CONST_REF(insn->op2) && (ctx->use_lists[insn->op2].count == 1 || all_usages_are_fusable(ctx, insn->op2))) {
 				op2_insn = &ctx->ir_base[insn->op2];
 				if (op2_insn->op >= IR_EQ && op2_insn->op <= IR_UNORDERED) {
 					if (IR_IS_TYPE_INT(ctx->ir_base[op2_insn->op1].type)) {
@@ -1168,13 +1196,13 @@
 			}
 		case IR_GUARD:
 		case IR_GUARD_NOT:
-			if (!IR_IS_CONST_REF(insn->op2) && ctx->use_lists[insn->op2].count == 1) {
+			if (!IR_IS_CONST_REF(insn->op2) && (ctx->use_lists[insn->op2].count == 1 || all_usages_are_fusable(ctx, insn->op2))) {
 				op2_insn = &ctx->ir_base[insn->op2];
-				if (op2_insn->op >= IR_EQ && op2_insn->op <= IR_UNORDERED
+				if (op2_insn->op >= IR_EQ && op2_insn->op <= IR_UNORDERED) {
 					// TODO: register allocator may clobber operands of CMP before they are used in the GUARD_CMP
-				 && (insn->op2 == ref - 1 ||
-				     (insn->op2 == ctx->prev_ref[ref] - 1
-				   && ctx->ir_base[ctx->prev_ref[ref]].op == IR_SNAPSHOT))) {
+//???				 && (insn->op2 == ref - 1 ||
+//???				     (insn->op2 == ctx->prev_ref[ref] - 1
+//???				   && ctx->ir_base[ctx->prev_ref[ref]].op == IR_SNAPSHOT))) {
 					if (IR_IS_TYPE_INT(ctx->ir_base[op2_insn->op1].type)) {
 						ctx->rules[insn->op2] = IR_FUSED | IR_CMP_INT;
 						return IR_GUARD_CMP_INT;
@@ -3084,7 +3112,7 @@
 	}
 }
 
-static ir_op ir_emit_cmp_fp_common(ir_ctx *ctx, ir_ref cmp_ref, ir_insn *cmp_insn)
+static ir_op ir_emit_cmp_fp_common(ir_ctx *ctx, ir_ref root, ir_ref cmp_ref, ir_insn *cmp_insn)
 {
 	ir_backend_data *data = ctx->data;
 	dasm_State **Dst = &data->dasm_state;
@@ -3093,16 +3121,12 @@
 	ir_ref op1, op2;
 	ir_reg op1_reg, op2_reg;
 
-	if (op == IR_LT || op == IR_LE) {
-		/* swap operands to avoid P flag check */
-		op ^= 3;
-		op1 = cmp_insn->op2;
-		op2 = cmp_insn->op1;
-		op1_reg = ctx->regs[cmp_ref][2];
-		op2_reg = ctx->regs[cmp_ref][1];
+	op1 = cmp_insn->op1;
+	op2 = cmp_insn->op2;
+	if (UNEXPECTED(ctx->rules[cmp_ref] & IR_FUSED_REG)) {
+		op1_reg = ir_get_fused_reg(ctx, root, cmp_ref * sizeof(ir_ref) + 1);
+		op2_reg = ir_get_fused_reg(ctx, root, cmp_ref * sizeof(ir_ref) + 2);
 	} else {
-		op1 = cmp_insn->op1;
-		op2 = cmp_insn->op2;
 		op1_reg = ctx->regs[cmp_ref][1];
 		op2_reg = ctx->regs[cmp_ref][2];
 	}
@@ -3131,7 +3155,7 @@
 {
 	ir_backend_data *data = ctx->data;
 	dasm_State **Dst = &data->dasm_state;
-	ir_op op = ir_emit_cmp_fp_common(ctx, def, insn);
+	ir_op op = ir_emit_cmp_fp_common(ctx, def, def, insn);
 	ir_reg def_reg = IR_REG_NUM(ctx->regs[def][0]);
 //???	ir_reg tmp_reg = ctx->regs[def][3]; // TODO: take into account vs flag
 
@@ -3348,8 +3372,15 @@
 	ir_type type = ctx->ir_base[cmp_insn->op1].type;
 	ir_ref op1 = cmp_insn->op1;
 	ir_ref op2 = cmp_insn->op2;
-	ir_reg op1_reg = ctx->regs[insn->op2][1];
-	ir_reg op2_reg = ctx->regs[insn->op2][2];
+	ir_reg op1_reg, op2_reg;
+
+	if (UNEXPECTED(ctx->rules[insn->op2] & IR_FUSED_REG)) {
+		op1_reg = ir_get_fused_reg(ctx, def, insn->op2 * sizeof(ir_ref) + 1);
+		op2_reg = ir_get_fused_reg(ctx, def, insn->op2 * sizeof(ir_ref) + 2);
+	} else {
+		op1_reg = ctx->regs[insn->op2][1];
+		op2_reg = ctx->regs[insn->op2][2];
+	}
 
 	if (op1_reg != IR_REG_NONE && IR_REG_SPILLED(op1_reg)) {
 		op1_reg = IR_REG_NUM(op1_reg);
@@ -3390,7 +3421,7 @@
 
 static void ir_emit_cmp_and_branch_fp(ir_ctx *ctx, uint32_t b, ir_ref def, ir_insn *insn, uint32_t next_block)
 {
-	ir_op op = ir_emit_cmp_fp_common(ctx, insn->op2, &ctx->ir_base[insn->op2]);
+	ir_op op = ir_emit_cmp_fp_common(ctx, def, insn->op2, &ctx->ir_base[insn->op2]);
 	ir_emit_jcc(ctx, b, def, insn, next_block, op, 0);
 }
 
@@ -3459,14 +3490,14 @@
 			op3_reg = op2_reg;
 		}
 	}
-	if (op3 != op2 && IR_REG_SPILLED(op3_reg)) {
+	if (IR_REG_SPILLED(op3_reg)) {
 		op3_reg = IR_REG_NUM(op3_reg);
 		ir_emit_load(ctx, type, op3_reg, op3);
-		if (op1 == op2) {
+		if (op1 == op3) {
 			op1_reg = op3_reg;
 		}
 	}
-	if (op1 != op2 && op1 != op3 && IR_REG_SPILLED(op1_reg)) {
+	if (IR_REG_SPILLED(op1_reg)) {
 		op1_reg = IR_REG_NUM(op1_reg);
 		ir_emit_load(ctx, op1_type, op1_reg, op1);
 	}
@@ -5682,9 +5713,16 @@
 	ir_type type = ctx->ir_base[cmp_insn->op1].type;
 	ir_ref op1 = cmp_insn->op1;
 	ir_ref op2 = cmp_insn->op2;
-	ir_reg op1_reg = ctx->regs[insn->op2][1];
-	ir_reg op2_reg = ctx->regs[insn->op2][2];
 	void *addr;
+	ir_reg op1_reg, op2_reg;
+
+	if (UNEXPECTED(ctx->rules[insn->op2] & IR_FUSED_REG)) {
+		op1_reg = ir_get_fused_reg(ctx, def, insn->op2 * sizeof(ir_ref) + 1);
+		op2_reg = ir_get_fused_reg(ctx, def, insn->op2 * sizeof(ir_ref) + 2);
+	} else {
+		op1_reg = ctx->regs[insn->op2][1];
+		op2_reg = ctx->regs[insn->op2][2];
+	}
 
 	if (op1_reg != IR_REG_NONE && IR_REG_SPILLED(op1_reg)) {
 		op1_reg = IR_REG_NUM(op1_reg);
@@ -5738,7 +5776,7 @@
 
 static void ir_emit_guard_cmp_fp(ir_ctx *ctx, uint32_t b, ir_ref def, ir_insn *insn)
 {
-	ir_op op = ir_emit_cmp_fp_common(ctx, insn->op2, &ctx->ir_base[insn->op2]);
+	ir_op op = ir_emit_cmp_fp_common(ctx, def, insn->op2, &ctx->ir_base[insn->op2]);
 	void *addr = ir_jmp_addr(ctx, insn, &ctx->ir_base[insn->op3]);
 
 	if (insn->op == IR_GUARD) {
@@ -7143,7 +7181,7 @@
 	return n;
 }
 
-bool ir_needs_thunk(ir_code_buffer *code_buffer, void *addr)
+bool ir_needs_thunk(const ir_code_buffer *code_buffer, void *addr)
 {
 	return !aarch64_may_use_b(code_buffer, addr);
 }
diff '--color=auto' -Naur php-8.4.18/ext/opcache/jit/ir/ir.c php-8.4.20RC1/ext/opcache/jit/ir/ir.c
--- php-8.4.18/ext/opcache/jit/ir/ir.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/jit/ir/ir.c	2026-04-01 04:35:36.007920439 +0000
@@ -858,7 +858,7 @@
 static ir_ref _ir_fold_cse(ir_ctx *ctx, uint32_t opt, ir_ref op1, ir_ref op2, ir_ref op3)
 {
 	ir_ref ref = ctx->prev_insn_chain[opt & IR_OPT_OP_MASK];
-	ir_insn *insn;
+	const ir_insn *insn;
 
 	if (ref) {
 		ir_ref limit = ctx->fold_cse_limit;
@@ -954,7 +954,8 @@
  * ANY and UNUSED ops are represented by 0
  */
 
-ir_ref ir_folding(ir_ctx *ctx, uint32_t opt, ir_ref op1, ir_ref op2, ir_ref op3, ir_insn *op1_insn, ir_insn *op2_insn, ir_insn *op3_insn)
+ir_ref ir_folding(ir_ctx *ctx, uint32_t opt, ir_ref op1, ir_ref op2, ir_ref op3,
+                  const ir_insn *op1_insn, const ir_insn *op2_insn, const ir_insn *op3_insn)
 {
 	uint8_t op;
 	ir_ref ref;
@@ -1136,9 +1137,9 @@
 	ir_insn_set_op(insn, n, val);
 }
 
-ir_ref ir_get_op(ir_ctx *ctx, ir_ref ref, int32_t n)
+ir_ref ir_get_op(const ir_ctx *ctx, ir_ref ref, int32_t n)
 {
-	ir_insn *insn = &ctx->ir_base[ref];
+	const ir_insn *insn = &ctx->ir_base[ref];
 
 #ifdef IR_DEBUG
 	if (n > 3) {
@@ -1419,13 +1420,21 @@
 		if (old_size < new_size) {
 			/* Reallocate the whole edges buffer (this is inefficient) */
 			ctx->use_edges = ir_mem_realloc(ctx->use_edges, new_size);
+			if (n == ctx->use_edges_count) {
+				ctx->use_edges[n] = ref;
+				use_list->count++;
+				ctx->use_edges_count++;
+				return 1;
+			}
 		} else if (n == ctx->use_edges_count) {
 			ctx->use_edges[n] = ref;
 			use_list->count++;
 			ctx->use_edges_count++;
 			return 0;
 		}
-		memcpy(ctx->use_edges + ctx->use_edges_count, ctx->use_edges + use_list->refs, use_list->count * sizeof(ir_ref));
+		if (use_list->count) {
+			memcpy(ctx->use_edges + ctx->use_edges_count, ctx->use_edges + use_list->refs, use_list->count * sizeof(ir_ref));
+		}
 		use_list->refs = ctx->use_edges_count;
 		ctx->use_edges[use_list->refs + use_list->count] = ref;
 		use_list->count++;
@@ -2025,7 +2034,7 @@
 
 ir_alias ir_check_partial_aliasing(const ir_ctx *ctx, ir_ref addr1, ir_ref addr2, ir_type type1, ir_type type2)
 {
-	ir_insn *insn1, *insn2;
+	const ir_insn *insn1, *insn2;
 	ir_ref base1, base2, off1, off2;
 
 	/* this must be already check */
@@ -2117,9 +2126,9 @@
 	return IR_MAY_ALIAS;
 }
 
-IR_ALWAYS_INLINE ir_ref ir_find_aliasing_load_i(ir_ctx *ctx, ir_ref ref, ir_type type, ir_ref addr, ir_ref limit)
+IR_ALWAYS_INLINE ir_ref ir_find_aliasing_load_i(const ir_ctx *ctx, ir_ref ref, ir_type type, ir_ref addr, ir_ref limit)
 {
-	ir_insn *insn;
+	const ir_insn *insn;
 	uint32_t modified_regset = 0;
 
 	while (ref > limit) {
@@ -2159,7 +2168,7 @@
 		} else if (insn->op == IR_RSTORE) {
 			modified_regset |= (1 << insn->op3);
 		} else if (insn->op == IR_CALL) {
-			ir_insn *func = &ctx->ir_base[insn->op2];
+			const ir_insn *func = &ctx->ir_base[insn->op2];
 			ir_ref func_proto;
 			const ir_proto_t *proto;
 
@@ -2186,14 +2195,14 @@
 	return IR_UNUSED;
 }
 
-ir_ref ir_find_aliasing_load(ir_ctx *ctx, ir_ref ref, ir_type type, ir_ref addr)
+ir_ref ir_find_aliasing_load(const ir_ctx *ctx, ir_ref ref, ir_type type, ir_ref addr)
 {
 	return ir_find_aliasing_load_i(ctx, ref, type, addr, (addr > 0 && addr < ref) ? addr : 1);
 }
 
-IR_ALWAYS_INLINE ir_ref ir_find_aliasing_vload_i(ir_ctx *ctx, ir_ref ref, ir_type type, ir_ref var)
+IR_ALWAYS_INLINE ir_ref ir_find_aliasing_vload_i(const ir_ctx *ctx, ir_ref ref, ir_type type, ir_ref var)
 {
-	ir_insn *insn;
+	const ir_insn *insn;
 
 	while (ref > var) {
 		insn = &ctx->ir_base[ref];
@@ -2224,7 +2233,7 @@
 				}
 			}
 		} else if (insn->op == IR_CALL) {
-			ir_insn *func = &ctx->ir_base[insn->op2];
+			const ir_insn *func = &ctx->ir_base[insn->op2];
 			ir_ref func_proto;
 			const ir_proto_t *proto;
 
@@ -2251,7 +2260,7 @@
 	return IR_UNUSED;
 }
 
-ir_ref ir_find_aliasing_vload(ir_ctx *ctx, ir_ref ref, ir_type type, ir_ref var)
+ir_ref ir_find_aliasing_vload(const ir_ctx *ctx, ir_ref ref, ir_type type, ir_ref var)
 {
 	return ir_find_aliasing_vload_i(ctx, ref, type, var);
 }
@@ -2547,12 +2556,12 @@
 	}
 }
 
-static ir_ref _ir_fold_condition(ir_ctx *ctx, ir_ref ref)
+static ir_ref _ir_fold_condition(const ir_ctx *ctx, ir_ref ref)
 {
-	ir_insn *insn = &ctx->ir_base[ref];
+	const ir_insn *insn = &ctx->ir_base[ref];
 
 	if (insn->op == IR_NE && IR_IS_CONST_REF(insn->op2)) {
-		ir_insn *op2_insn = &ctx->ir_base[insn->op2];
+		const ir_insn *op2_insn = &ctx->ir_base[insn->op2];
 
 		if (IR_IS_TYPE_INT(op2_insn->type) && op2_insn->val.u64 == 0) {
 			ref = insn->op1;
@@ -2565,7 +2574,7 @@
 		ref = insn->op1;
 		insn = &ctx->ir_base[ref];
 	} else if (insn->op == IR_EQ && insn->op2 == IR_NULL) {
-		ir_insn *op1_insn = &ctx->ir_base[insn->op1];
+		const ir_insn *op1_insn = &ctx->ir_base[insn->op1];
 		if (op1_insn->op == IR_ALLOCA || op1_insn->op == IR_VADDR) {
 			return IR_FALSE;
 		}
@@ -2577,10 +2586,10 @@
 	return ref;
 }
 
-IR_ALWAYS_INLINE ir_ref ir_check_dominating_predicates_i(ir_ctx *ctx, ir_ref ref, ir_ref condition, ir_ref limit)
+IR_ALWAYS_INLINE ir_ref ir_check_dominating_predicates_i(const ir_ctx *ctx, ir_ref ref, ir_ref condition, ir_ref limit)
 {
-	ir_insn *prev = NULL;
-	ir_insn *insn;
+	const ir_insn *prev = NULL;
+	const ir_insn *insn;
 
 	while (ref > limit) {
 		insn = &ctx->ir_base[ref];
@@ -2610,7 +2619,7 @@
 	return condition;
 }
 
-ir_ref ir_check_dominating_predicates(ir_ctx *ctx, ir_ref ref, ir_ref condition)
+ir_ref ir_check_dominating_predicates(const ir_ctx *ctx, ir_ref ref, ir_ref condition)
 {
 	IR_ASSERT(!IR_IS_CONST_REF(condition));
 	return ir_check_dominating_predicates_i(ctx, ref, condition, (condition < ref) ? condition : 1);
@@ -2751,7 +2760,7 @@
 
 		/* count inputs count */
 		do {
-			ir_insn *insn = &ctx->ir_base[ref];
+			const ir_insn *insn = &ctx->ir_base[ref];
 
 			IR_ASSERT(insn->op == IR_END);
 			ref = insn->op2;
@@ -2781,8 +2790,10 @@
 
 ir_ref _ir_PHI_LIST(ir_ctx *ctx, ir_ref list)
 {
-	ir_insn *merge, *end;
-	ir_ref phi, *ops, i;
+	const ir_insn *merge;
+	const ir_ref *ops;
+	ir_insn *end;
+	ir_ref phi, i;
 	ir_type type;
 
 	if (list == IR_UNUSED) {
@@ -3246,7 +3257,8 @@
 	if (EXPECTED(ctx->flags & IR_OPT_FOLDING)) {
 		ref = ir_find_aliasing_vload_i(ctx, ctx->control, type, var);
 		if (ref) {
-			ir_insn *insn = &ctx->ir_base[ref];
+			const ir_insn *insn = &ctx->ir_base[ref];
+
 			if (insn->type == type) {
 				return ref;
 			} else if (ir_type_size[insn->type] == ir_type_size[type]) {
@@ -3312,7 +3324,8 @@
 		}
 		ref = ir_find_aliasing_load_i(ctx, ctx->control, type, addr, (addr > 0) ? addr : 1);
 		if (ref) {
-			ir_insn *insn = &ctx->ir_base[ref];
+			const ir_insn *insn = &ctx->ir_base[ref];
+
 			if (insn->type == type) {
 				return ref;
 			} else if (ir_type_size[insn->type] == ir_type_size[type]) {
diff '--color=auto' -Naur php-8.4.18/ext/opcache/jit/ir/ir_cfg.c php-8.4.20RC1/ext/opcache/jit/ir/ir_cfg.c
